with Interfaces.C, POSIX.C;
with Ada.Text_IO; use Ada;

procedure chronos_test is

package C renames Interfaces.C;

type Timespec_Access is access all POSIX.Timespec;

function set_scheduler(scheduler, prio: C.int; cpus: C.unsigned_long) return C.long;
pragma import(C, set_scheduler); -- have the compiler choose the link name

function begin_rtseg_selfbasic(prio: C.int; deadline, period: Timespec_Access) return C.long;
pragma import(C, begin_rtseg_selfbasic); -- have the compiler choose the link name

function end_rtseg_self(prio: C.int) return C.long;
pragma import(C, end_rtseg_self); -- have the compiler choose the link name

rc : C.long;
deadline : aliased POSIX.Timespec;
period : aliased POSIX.Timespec;
scheduler : C.int := 256;
prio : C.int := 0;
run_prio : C.int := 40;
end_prio : C.int := 41;
mask : C.unsigned_long :=3;
p_deadline : Timespec_Access := deadline'Access;
p_period : Timespec_Access := period'Access;

begin

rc := set_scheduler(scheduler, prio, mask);
Text_IO.put_line(Text_IO.current_error, "setscheduler returns" & C.long'image(rc));

rc := begin_rtseg_selfbasic(run_prio, p_deadline, p_period);
Text_IO.put_line(Text_IO.current_error, "begin_rt_seg returns" & C.long'image(rc));

rc := end_rtseg_self(end_prio);
Text_IO.put_line(Text_IO.current_error, "end_rt_seg returns" & C.long'image(rc));
end chronos_test;
