#!/bin/bash

if [ $(/usr/bin/id -u) -ne 0 ]; then
	echo "Run this script with sudo"
	exit 2
fi

echo -1 > /proc/sys/kernel/sched_rt_runtime_us

cpuinfo=$(cat /proc/cpuinfo)
cpuspeed=$(echo "$cpuinfo" | grep -m 1 "MHz")
echo "Current system speed is ${cpuspeed:11:4} MHz"

echo Running ChronOS_Mutex Benchmark...
./chronos_mutex_benchmark
echo
echo Running ChronOS_Segment Benchmark...
./chronos_seg_benchmark
echo
echo Running Preemption Benchmark...
./preemption_benchmark 256 0 1
echo
echo Running Migration Benchmark...
./migration_benchmark 256 0 1
echo
echo Running Sleep Benchmark...
./sleep_benchmark
echo
echo Running Slope Benchmark...
./period_thread_benchmark
echo
echo Running Slope Benchmark...
./slope_benchmark
echo
echo Running Operations Benchmark...
./operation_benchmark
