
/*
 * example of one sporadic/aperiodic task without phase
 */


//#include "samples.h"

#include <stdio.h>
#include <pthread.h>

#include <sys/types.h>
#include <unistd.h>

#include "libchronos/chronos.h"

#define RUN_PRIO 90
#define END_PRIO 91

int main(int argc, char* argv[])
{
	long i, l;
	unsigned long mask = 1;

	struct timespec time, deadline, period;
	struct sched_param param;

	//set_scheduler(SCHED_RT_FIFO, -1, mask);
	set_scheduler(SCHED_RT_RMA, RUN_PRIO, mask);

		//set one second
		param.sched_priority = 99;
		period.tv_sec = 1;
		period.tv_nsec = 0;

		clock_gettime(CLOCK_REALTIME, &deadline);
		deadline.tv_sec++;

		sched_setaffinity(0, sizeof(mask), (cpu_set_t *) &mask);
		sched_setscheduler(0, SCHED_FIFO, &param);

		begin_rtseg_self(RUN_PRIO, 50, &deadline, &period, 100);
		{
		l = 123456789;
		for (i=0; i<1024; i++)
			l *= i;
		i=l;
		}
		end_rtseg_self(END_PRIO);

	return 0;
}

// works with both SCHED_RT_FIFO and SCHED_RT_RMA
