
/*
 * example of one periodic task without phase
 */

#include <stdio.h>
#include <pthread.h>

#include <sys/types.h>
#include <unistd.h>

#include "libchronos/chronos.h"

#define RUN_PRIO 90
#define END_PRIO 91

int main(int argc, char* argv[])
{
	long ii, i, l;
	unsigned long mask = 1;
	unsigned long tardiness;
	long long sec, nsec;

	struct timespec time, deadline, period;
	struct sched_param param;

// this must be done at load time
	//set_scheduler(SCHED_RT_FIFO, -1, mask);
	set_scheduler(SCHED_RT_RMA, RUN_PRIO, mask);

// periodic section related to the task

		//set one second
		param.sched_priority = 99;
		period.tv_sec = 1;
		period.tv_nsec = 0;

		sched_setaffinity(0, sizeof(mask), (cpu_set_t *) &mask);
		sched_setscheduler(0, SCHED_FIFO, &param);
	l = 3;

	clock_gettime(CLOCK_REALTIME, &deadline);
	//periodic loop
	for (ii=0; ii<32; ii++) {

		//calculate deadline
		deadline.tv_sec++;

		begin_rtseg_self(RUN_PRIO, 50, &deadline, &period, 100);
		{ // periodic task
		for (i=1; i<63; i++) {
			l *= i; l >>= 1;
		}
		i=l;
		printf("%d\n",i);
		}
		end_rtseg_self(END_PRIO);

		clock_gettime(CLOCK_REALTIME, &time);
		sec = deadline.tv_sec - time.tv_sec;
		nsec = deadline.tv_nsec - time.tv_nsec;
		if (nsec < 0) {
			nsec += 1000000000;
			sec--; }
		tardiness = (sec*1000000000 + nsec)/ 1000;

		if (tardiness > 0) {
			usleep(tardiness);
			//printf("tardiness %ld\n", tardiness);
		}
		else
			printf("tardiness %ld\n", tardiness);
	}

	return 0;
}
