/*
 * this version create one thread that executes RT segments
 */

//#include "samples.h"

#include <stdio.h>
#include <pthread.h>

#include <sys/types.h>
#include <unistd.h>

#include "libchronos/chronos.h"

#define RUN_PRIO 90
#define END_PRIO 91

#define THOUSAND 1000
#define MILLION 1000000
#define BILLION 1000000000

// long is in usec timespec in nsec
void long_to_timespec(unsigned long l, struct timespec *tspec)
{
	tspec->tv_sec = l/MILLION;
	tspec->tv_nsec = (l%MILLION)*THOUSAND;
}

// returned long is usec, timespec in ns
unsigned long timespec_to_long(const struct timespec *ts)
{
	return ts->tv_sec*MILLION + ts->tv_nsec/THOUSAND;
}

// result in nsec
/*
long long subtract_timespec(struct timespec *time2, struct timespec *time1)
{
	long long sec, nsec;
	sec = time2->tv_sec - time1->tv_sec;
	nsec = time2->tv_nsec - time1->tv_nsec;
	if (nsec < 0) {
		nsec += BILLION;
		sec--; }
	return (sec*BILLION + nsec);
}
*/

//static inline long long timespec_subtract_us(struct timespec *x,
	//				     struct timespec *y)
 long timespec_subtract_us(struct timespec *x,
					     struct timespec *y)

{
/*	long long sec, nsec;
	sec = x->tv_sec - y->tv_sec;
	nsec = x->tv_nsec - y->tv_nsec;
	if (nsec < 0) { //overflow
		nsec += BILLION;
		sec--;
	}
*/
//	unsigned long long llx = (x->tv_sec * BILLION) + x->tv_nsec;
//	unsigned long long lly = (y->tv_sec * BILLION) + y->tv_nsec;
//printf("llx %lld lly %lld\n", llx, lly);
//return ( (llx - lly)/ THOUSAND);

	/*unsigned long lx = (x->tv_sec * MILLION) + (x->tv_nsec/THOUSAND);
	unsigned long ly = (y->tv_sec * MILLION) + (y->tv_nsec/THOUSAND);
printf("lx %uld ly %lud\n", lx, ly);
*/
	/*if ( (x->tv_sec => y->tv_sec) && (x->tv_nsec => y->tv_nsec ) ) {
		// monotonically inc : positive results
		if ((llx - lly) < 0)

	} else		*///return lx - ly;

	 //long lx  = timespec_to_long(x);
	long lx  = (unsigned long)((x->tv_sec * MILLION) + (x->tv_nsec/THOUSAND));
	//return lxs - timespec_to_long(y);
	return lx - (long)(unsigned long)((y->tv_sec * BILLION) + (y->tv_nsec/THOUSAND));
}

// periodic section related to the task
void * periodic_thread (void * arg) {
	long ii, i, l, lll, ldeadline, lperiod;
	unsigned long mask = 1;
	long long tardiness;

	struct timespec time, deadline, period;
	struct sched_param param;

	//set one second period
	param.sched_priority = 99;

	lperiod = 1000000; // in usec
	long_to_timespec(lperiod, &period);

	sched_setaffinity(0, sizeof(mask), (cpu_set_t *) &mask);
	sched_setscheduler(0, SCHED_FIFO, &param);

	l = 3;

// initial phase
	usleep(1000);

	clock_gettime(CLOCK_REALTIME, &deadline);
	ldeadline = timespec_to_long(&deadline); //returned value in usec

//periodic loop
	for (ii=0; ii<32; ii++) {

		//calculate deadline
//	if ((deadline.tv_sec == 0) && (deadline.tv_nsec == 0)) { //first run
//
		ldeadline += lperiod;
		printf("deadline %ld\n", ldeadline);
		long_to_timespec(ldeadline, &deadline);

//		if ( (lll = timespec_to_long(&deadline)) != ldeadline) {
//			printf("lll %ld differ ldeadline %ld\n", lll, ldeadline);
//		}

		begin_rtseg_self(RUN_PRIO, 50, &deadline, &period, 100);
		{ // periodic task
			for (i=1; i<63; i++) {
				l *= i; l >>= 1;
			}
			i=l;
			printf("%ld\n",i);
		}
		end_rtseg_self(END_PRIO);

		clock_gettime(CLOCK_REALTIME, &time);
		//printf("time %ld\n", timespec_to_long(&time));
		//tardiness = timespec_subtract_us(&deadline, &time);
		tardiness = ldeadline - timespec_to_long(&time);
		printf("tardiness %lld\n", (tardiness));

		if (tardiness > 0) {
			usleep(tardiness);
		}
	}

	pthread_exit(NULL);

}


int main(int argc, char* argv[])
{
	unsigned long mask = 1;
	pthread_t ptt;

// in a global section you have to set the schedulers for each CPU
// this must be done at load time
	//set_scheduler(SCHED_RT_FIFO, -1, mask);
	set_scheduler(SCHED_RT_RMA, RUN_PRIO, mask);

	if (pthread_create(&ptt, 0, periodic_thread, 0)) {
				printf("Failed to pthread_create one of the task threads.");
				return 0;
	}
	if (pthread_join(ptt, NULL)) {
			printf("Failed to pthread_join one of the task threads.");
			return 0;
	}

	return 0;
}
