#include "samples.h"

#define RUN_PRIO 90
#define END_PRIO 91

unsigned long long time1, time2, time3, time4, time5, time6, time7;
unsigned long long tid_times[1000], begin_times[1000], end_times[1000], clk_times[1000], scheda_times[1000], scheds_times[1000];

void task() {
	int i;
	unsigned long mask = 1;
	struct timespec time;
	struct timespec deadline, period;
	struct sched_param param;

	param.sched_priority = 99;
	period.tv_sec = 1;
	period.tv_nsec = 0;
	clock_gettime(CLOCK_REALTIME, &deadline);
	deadline.tv_sec++;

	for(i = 0; i < 1000; i++) {
		time1 = RDTSC();
		begin_rtseg_self(RUN_PRIO, 50, &deadline, &period, 100);
		time2 = RDTSC();
		end_rtseg_self(END_PRIO);
		time3 = RDTSC();
		gettid();
		time4 = RDTSC();
		syscall(__NR_clock_gettime, CLOCK_REALTIME, &time);
		time5 = RDTSC();
		sched_setaffinity(0, sizeof(mask), (cpu_set_t *) &mask);
		time6 = RDTSC();
		sched_setscheduler(0, SCHED_FIFO, &param);
		time7 = RDTSC();

		begin_times[i] = time2 - time1;
		end_times[i] = time3 - time2;
		tid_times[i] = time4 - time3;
		clk_times[i] = time5 - time4;
		scheda_times[i] = time6 - time5;
		scheds_times[i] = time7 - time6;
	}
}

int main()
{
	struct stat_data begin_time, end_time, tid_time, clk_time, scheda_time, scheds_time;
	unsigned long mask = 1;

	if(prep_test())
		return 1;

	set_scheduler(SCHED_RT_FIFO, -1, mask);

	task();

	selection_sort(begin_times, 1000);
	selection_sort(end_times, 1000);
	selection_sort(tid_times, 1000);
	selection_sort(clk_times, 1000);
	selection_sort(scheda_times, 1000);
	selection_sort(scheds_times, 1000);

	begin_time = stats(begin_times, 990);
	end_time = stats(end_times, 990);
	tid_time = stats(tid_times, 990);
	clk_time = stats(clk_times, 990);
	scheda_time = stats(scheda_times, 990);
	scheds_time = stats(scheds_times, 990);

	cout << "Begin_rt_seg\t\t" << stat_print_long(begin_time) << endl;
	cout << "End_rt_seg\t\t" << stat_print_long(end_time) << endl;
	cout << "Gettid\t\t\t" << stat_print_long(tid_time) << endl;
	cout << "Clock_Gettime\t\t" << stat_print_long(clk_time) << endl;
	cout << "Sched_setaffinity\t" << stat_print_long(scheda_time) << endl;
	cout << "Sched_setscheduler\t" << stat_print_long(scheds_time) << endl;

	return 0;
}

