#include "samples.h"

#define BOUND 10000000

int main(int argc, char* argv[])
{
	int counter = 1, cascounter = 0, result = 0;
	volatile int vcounter = 1;
	unsigned long long time1, time2, time3, diff_time;

	if(prep_test())
		return 1;

	time1 = RDTSC();
	for(unsigned long i = 0; i < BOUND; i++) {
		result += counter;
	}
	time2 = RDTSC();
	for(unsigned long i = 0; i < BOUND; i++) {
		result += vcounter;
	}
	time3 = RDTSC();

	diff_time = time2 - time1;
	cout << "Normal read: " << diff_time/BOUND << " ticks" << endl;
	diff_time = time3 - time2;
	cout << "Volatile read: " << diff_time/BOUND << " ticks" << endl;

	time1 = RDTSC();
	for(unsigned long i = 0; i < BOUND; i++) {
		counter += i;
	}
	time2 = RDTSC();
	for(unsigned long i = 0; i < BOUND; i++) {
		vcounter += i;
	}
	time3 = RDTSC();
	
	diff_time = time2 - time1;
	cout << "Normal write: " << diff_time/BOUND << " ticks" << endl;
	diff_time = time3 - time2;
	cout << "Volatile write: " << diff_time/BOUND << " ticks" << endl;

	time1 = RDTSC();
	for(unsigned long i = 0; i < BOUND; i++) {
		__sync_fetch_and_add(&cascounter, i);
	}
	time2 = RDTSC();
	
	cascounter = 0;
	diff_time = time2 - time1;
	cout << "FAA write: " << diff_time/BOUND << " ticks" << endl;

	time1 = RDTSC();
	for(unsigned long i = 0; i < BOUND; i++) {
		__sync_lock_test_and_set(&cascounter, i);
	}
	time2 = RDTSC();
	
	cascounter = 0;
	diff_time = time2 - time1;
	cout << "XCHG Write: " << diff_time/BOUND << " ticks" << endl;

	time1 = RDTSC();
	for(unsigned long i = 0; i < BOUND; i++) {
		__sync_val_compare_and_swap(&cascounter, i, i+1);
	}
	time2 = RDTSC();
	
	diff_time = time2 - time1;
	cout << "CAS write: " << diff_time/BOUND << " ticks" << endl;
	
	return 0;
}

