#include "samples.h"

unsigned long long interval[1001];
int count = 0;
struct sched_param param;
pthread_attr_t attr;
timer_t timer;

void task(union sigval value) {
	if(count < 1001)
		interval[count] = RDTSC();
	count++;
        pthread_exit(NULL);
}

int main(int argc, char* argv[])
{
	unsigned long long times[1000];
	struct stat_data data;
	struct timespec period, now;

	if(prep_test())
		return 1;

	pthread_attr_init(&attr);
	pthread_attr_setschedparam(&attr, &param);
	param.sched_priority = 40;

	for(int i = 1; i < 10001; i *= 10) {
		count = 0;
		period.tv_sec = 0;
		period.tv_nsec = i*1000;

		clock_gettime(CLOCK_REALTIME, &now);
		make_periodic_threads(&timer, task, NULL, now, period, &attr);
		usleep(i*10000);
		delete_periodic_thread(timer);

		for(int j = 0; j < 1000; j++) {
			times[j] = interval[j + 1] - interval[j];
		}

		selection_sort(times, 1000);
		data = stats(times, 990);

		cout << i << " us " << stat_print(data) << endl;
	}

	return 0;
}

