#include "samples.h"

int main(int argc, char* argv[])
{
	double exec_slope;
	unsigned long long time1, time2, time3, time[1000], timea[1000];
	struct stat_data burn, burna;
	char abort = 0;

	exec_slope = get_burn_cpu_slope();
	if(exec_slope == 0) {
		cout << "Error: No slope found" << endl;
		return 0;
	}

	if(prep_test())
		return 1;

	cout << "Time\tW/o Aborts\tW/ Aborts" << endl;

	for(int i = 1; i <= 10000; i *= 10) {
		for(int j = 0; j < 1000; j++) {
			time1 = RDTSC();
			burn_cpu(i, exec_slope);
			time2 = RDTSC();
			burn_cpu_abort(i, exec_slope, &abort);
			time3 = RDTSC();
			time[j] = (time2 - time1);
			timea[j] = (time3 - time2);
		}


		selection_sort(time, 1000);
		selection_sort(timea, 1000);

		burn = stats(time, 990);
		burna = stats(timea, 990);

		cout << i << "us\t" << stat_print(burn) << "\t" << stat_print(burna) << endl;
	}

	return 0;
}

