#include "test.h"

unsigned long mask = 1;
chronos_aborts_t aborts;

struct timespec deadline;

void *task1(void *p)
{
	int thread_id = gettid();
	char *abort_flag = get_abort_ptr_tid(&aborts, thread_id);

	sched_setaffinity(0, sizeof(mask), (cpu_set_t *) &mask);

	THREAD_OUTPUT("thread %d - start \n", thread_id);
	clock_gettime(CLOCK_REALTIME, &deadline);
	deadline.tv_sec++;
	begin_rtseg_self(RUN_PRIO, 0, &deadline, NULL, 0);

	test_val *= 7;

	burn_cpu_abort(1500000, exec_slope, abort_flag);

	if(*abort_flag)
		test_val -= 9;

	end_rtseg_self(END_PRIO);
	THREAD_OUTPUT("thread %d - end\n", thread_id);
	pthread_exit(NULL);
}

int main(int argc, char* argv[])
{
	pthread_t t1;
	sched = SCHED_RT_HVDF;

	/* Establish the abort handler. */
	if(init_aborts(&aborts)) {
		cout << "Error: Unable to mmap abort device" << endl;
		cout << "Are you running as root?" << endl;
	}

	while ((c = getopt (argc, argv, optstring)) != -1)
	{
		switch (c) {
		case 'v' :
			verbose = true;
			break;
		case 'h' :
			cout << "A simple test for task abortability. Use -v for detailed output" << endl;
			return 0;
		}
	}

	exec_slope = get_burn_cpu_slope();
	if(exec_slope == 0) {
		cout << "Error: No slope found" << endl;
		return 0;
	}

	if(prep_test())
		return 1;

	if(set_scheduler(sched, -1, mask)) {
		cout << "Error: Unable to set scheduler" << endl;
		cout << "Are you running as root?" << endl;
	}

	test_val +=5;

	pthread_create(&t1, NULL, task1, NULL);
	pthread_join(t1, NULL);

	if(test_val == 47)
		cout << "Abort test successful" << endl;
	else
		cout << "Abort test failed: " << test_val << endl;

	return 0;
}

