#include "test.h"
#include <errno.h>

struct timespec period;
struct timespec deadline;
struct rt_data data;
chronos_mutex_t mutex;

int main(int argc, char* argv[])
{
	test_val = 0;
	sched = SCHED_RT_FIFO;
	unsigned long mask = 1;

	while ((c = getopt (argc, argv, optstring)) != -1)
	{
		switch (c) {
		case 'v' :
			verbose = true;
			break;
		case 'h' :
			cout << "A test to verify correct kernel behaviour in the presense of a mis-behaving userspace program. Use -v for detailed output" << endl;
			return 0;
		}
	}

	period.tv_sec = 0;
	period.tv_nsec = 0;

	deadline.tv_sec = 0;
	deadline.tv_nsec = 0;

	if(prep_test())
		return 1;

	set_scheduler(sched, -1, mask);

	data.tid = 0;
	data.max_util = 0;
	data.exec_time = 0;
	data.prio = RUN_PRIO;
	data.deadline = &deadline;
	data.period = &period;

	// Test Op Code
	if(syscall(__NR_do_rt_seg, -1, &data) == -1 && errno == EINVAL)
		test_val++;
	if(syscall(__NR_do_rt_seg, 4, &data) == -1 && errno == EINVAL)
		test_val++;
	if(syscall(__NR_do_rt_seg, 0, &data) == 0)
		test_val++;
	if(syscall(__NR_do_rt_seg, 1, &data) == 0)
		test_val++;
	if(syscall(__NR_do_rt_seg, 2, &data) == 0)
		test_val++;

	//Test Data pointer
	if(syscall(__NR_do_rt_seg, 0, NULL) == -1 && errno == EFAULT)
		test_val++;
	if(syscall(__NR_do_rt_seg, 1, NULL) == -1 && errno == EFAULT)
		test_val++;
	if(syscall(__NR_do_rt_seg, 2, NULL) == -1 && errno == EFAULT)
		test_val++;

	data.deadline = NULL;
	data.period = NULL;

	//Test Period and Deadline pointers
	if(syscall(__NR_do_rt_seg, 0, &data) == -1 && errno == EFAULT)
		test_val++;
	if(syscall(__NR_do_rt_seg, 1, &data) == 0)
		test_val++;
	if(syscall(__NR_do_rt_seg, 2, &data) == -1 && errno == EFAULT)
		test_val++;

	data.deadline = NULL;
	data.period = &period;

	//Test Period and Deadline pointers
	if(syscall(__NR_do_rt_seg, 0, &data) == -1 && errno == EFAULT)
		test_val++;
	if(syscall(__NR_do_rt_seg, 1, &data) == 0)
		test_val++;
	if(syscall(__NR_do_rt_seg, 2, &data) == -1 && errno == EFAULT)
		test_val++;

	data.deadline = &deadline;
	data.period = NULL;

	//Test Period and Deadline pointers
	if(syscall(__NR_do_rt_seg, 0, &data) == -1 && errno == EFAULT)
		test_val++;
	if(syscall(__NR_do_rt_seg, 1, &data) == 0)
		test_val++;
	if(syscall(__NR_do_rt_seg, 2, &data) == 0)
		test_val++;

	if(syscall(__NR_do_chronos_mutex, NULL, 0) == -1 && errno == EFAULT)
		test_val++;
	if(syscall(__NR_do_chronos_mutex, &mutex, 5) == -1 && errno == EINVAL)
		test_val++;
	if(syscall(__NR_do_chronos_mutex, &mutex, -1) == -1 && errno == EINVAL)
		test_val++;

	if(test_val == 20)
		cout << "Syscall safety test successful" << endl;
	else
		cout << "Syscall safety test failed: " << test_val << endl;

	return 0;
}

