/***************************************************************************
 *   Copyright (C) 2009-2011 Virginia Tech Real-Time Systems Lab	   *
 *   Written by Matthew Dellinger					   *
 *   mdelling@vt.edu							   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or	   *
 *   (at your option) any later version.				   *
 *									   *
 *   This program is distributed in the hope that it will be useful,	   *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of	   *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the	   *
 *   GNU General Public License for more details.			   *
 *									   *
 *   You should have received a copy of the GNU General Public License	   *
 *   along with this program; if not, write to the			   *
 *   Free Software Foundation, Inc.,					   *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.		   *
 ***************************************************************************/

#ifndef TEST_H
#define TEST_H

#include <sys/types.h>
#include <sys/syscall.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>
#include <chronos/chronos.h>
#include <chronos/chronos_utils.h>
#include <chronos/chronos_aborts.h>

#define THREAD_OUTPUT if(verbose) printf
#define RUN_PRIO 40
#define END_PRIO 45

#ifdef __cplusplus
#include <iostream>
#include <fstream>
using namespace std;

bool verbose = false;
#else
int verbose = 0;

/* Set the CPU affinity for a task */
extern int sched_setaffinity (__pid_t __pid, size_t __cpusetsize,
			      __const cpu_set_t *__cpuset) __THROW;
#endif

double exec_slope;
int sched, test_val = 3;
char c, optstring[]= "vh";

int prep_test() {
	struct sched_param param;
	unsigned long mask = 1;

	sched_setaffinity(0, sizeof(mask), (cpu_set_t *) &mask);
	param.sched_priority = 99;
	if(pthread_setschedparam(pthread_self(), SCHED_FIFO, &param)) {
#ifdef __cplusplus
		cout << "Unable to set the scheduler" << endl;
#else
		printf("Unable to set the scheduler\n");
#endif
		return 1;
	}

	// Lock the memory space
	if(mlockall(MCL_CURRENT|MCL_FUTURE)) {
#ifdef __cplusplus
		cout << "Unable to mlockall" << endl;
#else
		printf("Unable to mlockall\n");
#endif
		return 1;
	}

	return 0;
}

#endif
