/***************************************************************************
 *   Copyright (C) 2011 by Virginia Tech Real-Time Systems Lab             *
 *                                                                         *
 *   Author(s):                                                            *
 *       - Aaron Lindsay (aaron.lindsay@vt.edu)                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

package edu.vt.realtime;

public class ChronosMutex {
	private int value;
	private int owner;
	private long id;

	/* Make sure libjchronos is loaded so we can access the native methods */
	static{
		System.loadLibrary("jchronos");
	}

	public ChronosMutex() {
		this.mutexInit();
	}

	public int getOwner() {
		return this.mutexOwner();
	}

	public boolean lock() {
		return this.mutexLock();
	}

	public boolean unlock() {
		return this.mutexUnlock();
	}

	public void destroy() {
		this.mutexDestroy();
	}

	private native void mutexInit();
	private native void mutexDestroy();
	private int mutexOwner() { return this.owner; }
	private native boolean mutexLock();
	private native boolean mutexUnlock();
}
