/***************************************************************************
 *   Copyright (C) 2011 by Virginia Tech Real-Time Systems Lab             *
 *                                                                         *
 *   Author(s):                                                            *
 *       - Aaron Lindsay (aaron.lindsay@vt.edu)                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

package edu.vt.realtime;

public enum LinuxSchedulerType{
	SCHED_NORMAL(0),
	SCHED_FIFO(1),
	SCHED_RR(2),
	SCHED_BATCH(3);

	private final int nativeId;
	private LinuxSchedulerType(final int nativeId) {
		this.nativeId = nativeId; 
	}
	public final String displayString() {
		return this.name() + "(" + this.nativeId + ")";
	}
	public int getNativeId() {
		return nativeId;
	}

	public static LinuxSchedulerType typeFromInt(int type) {
		switch (type) {
			case 1:
				return LinuxSchedulerType.SCHED_FIFO;
			case 2:
				return LinuxSchedulerType.SCHED_RR;
			case 3:
				return LinuxSchedulerType.SCHED_BATCH;
			default:
				return LinuxSchedulerType.SCHED_NORMAL;
		}
	}
}
